#include <stdio.h>
#include <stdlib.h>
#include "palabras.c"
#include "rw_mp.h"
#include "6502core.h"
#include "op_palabras.h"
#include "sdl_emilnes.h"
#include <string.h>
#include "ppu_state.h"
#include "ppu.h"
#include "depuracion.h"
#include "sound.h"
#include "constantes.h"
#include "states.h"
#include "config.h"
//#include "./papu/NESAPU.h"
//#include <SDL_thread.h>
//#include <SDL/SDL.h>

int main(int argc, char *argv[])
{

  FILE *cartucho;
  void *pantalla;

  //VARIABLES DE CONFIGURACION

  char evaluacion = 2;
  int traza = 0;
  char optimo = 0;
  char full_screen = 0;
  int save = 0;
  int load = 0;
  int fr_inc = 0;
  int limitar_velocidad = 0;

  unsigned int bp[2];
  bp[0] = 0;
  bp[2] = 0xFFFF; //Para que no tenga brak en PC = 0;

  char ev_sen[] = "-s";
  char traza_sen[] = "-t";
  char optimo_sen[] = "-f";
  char full_sen[] = "-fs";
  char limit[]= "-l";

  //VARIABLES DE EXPCEPCION

  struct cpu6502 cpu;
  cpu.memory_map = NULL;

  unsigned long ciclo = 0; //Que ciclo de ejecucion es.
  int halt = 0; //Si esta a 1 se apaga la NES.

  //union tipo_palabra8* Cpu_mp = NULL;
#define TAM_BUFSOUND 2048
  unsigned char buf_sound[TAM_BUFSOUND];




  //*******************************************************************************************//
  //EMULACION DE LA NES PROPIAMENTE DICHA.
  //*******************************************************************************************//

  int nes_sim() //la bestia

  {
    //VARIABLES DE PPU
    struct ppu_data ppu;
    reset_ppu(&ppu,pantalla,&(cpu.memory_map));

    long origen;
    float factor=1.0; /*El emulador se ejecuta a velocidad real*/

    if (optimo == 1) cpu.memory_map[0x8FF].uns = 1;
    else cpu.memory_map[0x8FF].uns = 0xFF;
    //FIN VARIABLES PPU

    if (traza != 0) printf("");
    //Esto es de co�, si lo kito m salta el trazador.
    origen = SDL_GetTicks();

    //Inicializaciones varias
    reset6502(&cpu);



    while (halt != 1)
    {
      /***************************************************************************/
      /*EJECUCION DE CPU,PPU... excepto E/S*/
      /***************************************************************************/

      //PPU
      ejecutar_ppu(&ppu, &cpu.nmi);
      //PAPU
      //EAPU_RunToCycle(ciclo);
      //CPU

      ppu.ciclo_us += ejecutar(&halt,&cpu, &ciclo);

#ifdef DEBUG
      if ((halt == 0) && (traza != 0) && (ciclo > 0)) //Ejecutar trazador si procede
      {trazador(&halt,&cpu.IR,&cpu.PC,&cpu.SP,&cpu.X,&cpu.Y,&cpu.A,&cpu.P,cpu.memory_map, &cpu.brk_irq,bp,ciclo,ppu.line,&traza);   }
#endif
      //DMA
      dma_sim(cpu.memory_map);
      //FIN DMA

      /***************************************************************************/
      /*EJECUCION DEL GESTOR DE EVENTOS*/
      /***************************************************************************/

      if (ciclo % POLLING == 0)
      {
        if (cpu.reset == 1)cpu.memory_map = montar(cartucho, cpu.memory_map); //Se vuelve a motnar el cartucho.
        gestorev(&halt,&cpu.reset,&traza, &save, &load, &fr_inc, /*Cpu_mp,*/ pantalla);

        if ( (ciclo) % POLLING<<6 == 0)  //OBSERVAMOS SI HAY CAMBIOS EN ALGUNA OPCION.
        {if (evaluacion != 0)
          {
            if ((SDL_GetTicks() - origen) > TIEMPO_TEST)
            {
              if (evaluacion==1)
              {
                halt = 1;
                printf("Inst/sec: %i (375K in a real NES)\n\n", ciclo/(4*TIEMPO_TEST/1000));
              }
              else //Evaluacion == 2, estamos en periodo de evaluacion para determinar el skip
              {
                factor=auto_skip(&ppu.mod_mal,ciclo/(4*TIEMPO_TEST/1000));
                evaluacion=0;
                if ((factor>VEL_MAX) && (limitar_velocidad==1))
                 printf("EmilNES is running too fast, speed will be limited to %.4f\n", VEL_MAX);
              }
            }
          }
          else /*Hora de meter un retardo si hace falta (factor>1)*/
            {
              if ((factor>VEL_MAX) && (limitar_velocidad==1)) /*Paramos la emulacion un ratito*/
               SDL_Delay((int)((factor-VEL_MAX)*(((float)POLLING)/1700.0)));


            }
          if ((save != 0) && (save % 2 == 0))
          {
            salvar(argv[1],save/2,&cpu.PC,&cpu.SP,&cpu.X,&cpu.Y,&cpu.A,&cpu.P,cpu.memory_map);
            save = 0;
          }

          if ((load != 0) && (load % 2 == 0))
          {
            load_state(argv[1],load/2,&cpu.PC,&cpu.SP,&cpu.X,&cpu.Y,&cpu.A,&cpu.P,cpu.memory_map);
            load = 0;
          }

          if (fr_inc == 2)
          {
            ppu.mod_mal++;
            printf("FrameSkip set to: %ix\n", ppu.mod_mal);
            fr_inc = 0;
          }

          if (fr_inc == -2)
          {
            if (ppu.mod_mal > 1) ppu.mod_mal--;
            printf("FrameSkip set to: %ix\n", ppu.mod_mal);
            fr_inc = 0;
          }
        }
      }
      //FIN CPU



    }

    //INFORME
    printf("%i Instrucion were executed\n", ciclo/4);
    printf("fps: %i\n", ppu.frames/((SDL_GetTicks()-origen)/1000));
    return 0;
  }

  //*****************************************************************************************//
  //PROGRAMA PRINCIPAL
  //******************************************************************************************//

  //MIRAR LINEA DE COMANDOS

  if (argc == 1)
  {
    printf("Use: emilnes <nes rom file> [-fs] [-s|-t|-l]\n");
    printf("     -fs: Fullscreen Mode\n");
    printf("     -s:  Stats (CPU IPS & fps)\n");
    printf("     -t:  Ejecution Trace is shown\n");
    printf("     -l:  Limit speed\n\n");
    system("PAUSE"); exit(0);
  }

  if (argc >= 3)
  {
    if (strcmp(argv[2],ev_sen) == 0) {evaluacion = 1; printf("Evaluation mode enabled\n\n");}
    else if (strcmp(argv[2], traza_sen) == 0) {traza = 1; printf("Trace mode enabled\n\n");}
    else if (strcmp(argv[2], full_sen) == 0) {full_screen = 1; printf("Full Screen Mode Enabled\n\n");}
    else if (strcmp(argv[2], limit) == 0) {limitar_velocidad = 1; printf("Speed Limit Mode Enabled\n\n");}
  }

  if (argc == 4)
  {
    if (strcmp(argv[3],ev_sen) == 0) {evaluacion = 1; printf("Evaluation mode enabled\n\n");}
    else if (strcmp(argv[3], traza_sen) == 0) {traza = 1; printf("Trace mode enabled\n\n");}
    else if (strcmp(argv[2], limit) == 0) {limitar_velocidad = 1; printf("Speed Limit Mode Enabled\n\n");}
  }

  cartucho = fopen(argv[1],"rb");
  if (cartucho == 0) {fprintf(stderr,"File not found.\n"); exit(-1);}

  //FIN LINEA DE COMANDOS

  //CARGANDO LA VENTANA
  pantalla = init_sdl(full_screen);
  SDL_Delay(500);

  //CARGARNDO ROM Y APA�NDO LA APU
  //Inicializacion de la PAPU.

  cpu.memory_map = montar(cartucho, cpu.memory_map);

  //Comienza la simulacion de la NES
  nes_sim();

  //SALIENDO DE EMILNES
  cerrar_SDL();
  close(cartucho);  //Cerrar la ROM

}
