#include "palabras.c"
#include "joypad.h"


#include "constantes.h"

#define TCPU_MP 0x10000 //Esto no SE SI es CIERTO

//Por motivos de dependencia entre modulos:
//mp[0x810..0x830] se reservan para el estado de los joypads.
//mp[0x850..0x860] se reservan ppu
//mp[0x870..0x8B0] estado los sprites
//mp[0x8C0..0x8D0] variables del depurador
//mp[0x8FF]        variable que determina si se redibuja o no. (OJO CON EL DMA)
//mp[0x900..0xA00] es la SPR-RAM, 256 bytes, interna a PPU
//mp[0xA001..A03]  para hacer el DMA.
//0xA001 nmero de iteracion.
//0xA002 El N
//0xA003 si 0 no DMA si distinto (1) SI DMA.



union tipo_palabra8* montar (FILE *arch, union tipo_palabra8* mp)
{
  union tipo_palabra8 prg_bl; //numero pag prg y chk
  union tipo_palabra8 chk_bl;
  union tipo_palabra8 aux;

  unsigned char map_aux;
  int mirror;
  int map;
  //Si reiniciamos hay q liberar la memoria.
  if (mp != NULL) free(mp);

  //FORMA MEGA CUTRE DE COMPROBAR SI EL ROM ES VALIDO O NO (NOTA PARA FUTURO METER UN FOR)

  fseek(arch,0,SEEK_SET);
  fread( &prg_bl.uns, sizeof(prg_bl.uns), 1, arch );
  if (prg_bl.uns != 0x4E)
  {
    printf("This archive is not a valid ROM file or is corrupted\n");
    exit(-1);
  }

  fseek(arch,1,SEEK_SET);
  fread( &prg_bl.uns, sizeof(prg_bl.uns), 1, arch );
  if (prg_bl.uns != 0x45)
  {
    printf("This archive is not a valid ROM file or is corrupted\n");
    exit(-1);
  }

  fseek(arch,2,SEEK_SET);
  fread( &prg_bl.uns, sizeof(prg_bl.uns), 1, arch );
  if (prg_bl.uns != 0x53)
  {
    printf("This archive is not a valid ROM file or is corrupted\n");
    exit(-1);
  }

  fseek(arch,3,SEEK_SET);
  fread( &prg_bl.uns, sizeof(prg_bl.uns), 1, arch );
  if (prg_bl.uns != 0x1A)
  {
    printf("This archive is not a valid ROM file or is corrupted\n");
    exit(-1);
  }


  //SACAMOS EL NUMERO DE BANKOS

  fseek(arch,4,SEEK_SET);
  fread( &prg_bl.uns, sizeof(prg_bl.uns), 1, arch );
  fseek(arch,5,SEEK_SET);
  fread( &chk_bl.uns, sizeof(chk_bl.uns), 1, arch );

  //SACAMOS EL MIRRONING

  fseek(arch,6,SEEK_SET);
  fread( &aux.uns, sizeof(chk_bl.uns), 1, arch );

  mirror = sacar_bit(0,aux); //Obtenemos el Mirror que es.

  //FIN MIRROR

  //Sacamos el Mapper

  fseek(arch,6,SEEK_SET);
  fread(&map_aux,sizeof(unsigned char),1,arch);

  map = map_aux/16;

  fseek(arch,7,SEEK_SET);
  fread(&map_aux,sizeof(unsigned char),1,arch);

  map = map + (map_aux - (map_aux % 16));

  //Fin mapper

  //CREAR MEMORIA PRINCIPAL (El tama� varia segun el mapper)
  if (map == 0) mp = malloc(0x14000);
  else if (map == 2) mp = malloc(0x14000 + (prg_bl.uns-2)*0x4000);
  else if (map == 3) mp = malloc(0x14000 + (chk_bl.uns-1)*0x2000);
  else if (map == 1)
  {
    if (chk_bl.uns != 0)
      mp = malloc(0x14000 + (chk_bl.uns-1)*0x2000 + (prg_bl.uns-2)*0x4000);
    else mp = malloc(0x14000 + (prg_bl.uns-2)*0x4000);
  }
  else if (map == 4)
  {
    if (chk_bl.uns != 0)
      mp = malloc(0x14000 + (chk_bl.uns)*0x2000 + (prg_bl.uns)*0x4000 - 0x2000);
    else mp = malloc(0x14000 + (prg_bl.uns)*0x4000 - 0x2000);
  }
  else mp = malloc(0x14000); //pa q no se cuelgue que keda feo.
  //FIN CREACION


  //CARGAMOS LOS VECTORES DE INTERRUPCIONES
  fseek(arch,0xA+(0x4000)*prg_bl.uns,SEEK_SET); //Ppio Para leer
  fread(&mp[0xFFFA].uns,sizeof(unsigned char),6,arch);


  if (map == 0) //MAPPER 0.
  {
    if (prg_bl.uns == 1)
    {//SE CARGAN EL BLOQUE 2 veces en 0x8000 y 0xC000

      fseek(arch,0x10,SEEK_SET); //Ppio Para leer
      fread(&mp[0x8000].uns,sizeof(unsigned char),0x4000,arch);
      fseek(arch,0x10,SEEK_SET); //Ppio Para leer
      fread(&mp[0xC000].uns,sizeof(unsigned char),0x4000,arch);

    }
    else                   //Se cargan los 2 bloques seguidos.
    {
      fseek(arch,0x10,SEEK_SET); //Ppio Para leer
      fread(&mp[0x8000].uns,sizeof(unsigned char),(0x4000)*prg_bl.uns,arch);
    }

    //CARGAMOS CHR-ROM
    fseek(arch,0xA+(0x4000)*prg_bl.uns + 0x6,SEEK_SET); //Ppio Para leer
    fread(&mp[0x0000+TCPU_MP].uns,sizeof(unsigned char),(0x2000)*(chk_bl.uns),arch);

    //Se puede escribir en VRAM o no.
    if (chk_bl.uns != 0) mp[WR_VRAM].uns = 1;


  }//FIN MAPPER 0

  else if (map == 1)//MAPPER 1
  {
    //Cargamos el primer y ultimo bloque de PRG.
    fseek(arch,0x10,SEEK_SET); //Ppio Para leer
    fread(&mp[0x8000].uns,sizeof(unsigned char),0x4000,arch);
    fseek(arch,(0x4000)*(prg_bl.uns-1) + 0x10,SEEK_SET); //Ppio Para leer
    fread(&mp[0xC000].uns,sizeof(unsigned char),0x4000,arch);
    //Cargamos los demas bloques PRG.
    fseek(arch,0x4010,SEEK_SET); //Ppio Para leer
    fread(&mp[0x14000].uns,sizeof(unsigned char),0x4000*(prg_bl.uns-2),arch);

    //Cargamos el CHR.
    if (chk_bl.uns != 0)
    {//CARGAMOS el primer CHR-ROM
      fseek(arch,0xA+(0x4000)*prg_bl.uns + 0x6,SEEK_SET); //Ppio Para leer
      fread(&mp[0x10000].uns,sizeof(unsigned char),0x2000,arch);

      //CARGAMOS TODOS LOS DEMAS CHR-ROM
      fseek(arch,(0x4000)*prg_bl.uns + 0x10 + 0x2000,SEEK_SET); //Ppio Para leer
      fread(&mp[0x14000+0x4000*(prg_bl.uns-2)].uns,sizeof(unsigned char),0x2000*(chk_bl.uns-1),arch);
    }
    //RESETEAMOS EL MAPPER 1.

    mp[MAP1_CONT].uns = 0;
    mp[MAP1_REG0].uns = (mp[MAP1_REG0].uns | 0x0C);

  } //FIN MAPPER 1

  else if (map == 4)//MAPPER 4
  {

    fseek(arch,0x10,SEEK_SET); //Ppio Para leer
    fread(&mp[0x14000].uns,sizeof(unsigned char),0x4000*prg_bl.uns-0x2000,arch);
    fseek(arch,(0x4000)*(prg_bl.uns-1) + 0x2010,SEEK_SET); //Ultimo bloke de 8k
    fread(&mp[0xE000].uns,sizeof(unsigned char),0x2000,arch);

    //Cargamos el CHR.
    if (chk_bl.uns != 0)
    {
      //CARGAMOS TODOS LOS DEMAS CHR-ROM
      fseek(arch,(0x4000)*prg_bl.uns + 0x10,SEEK_SET); //Ppio Para leer
      fread(&mp[0x14000+0x4000*(prg_bl.uns)-0x2000].uns,sizeof(unsigned char),0x2000*chk_bl.uns,arch);
    }
    mp[MAP4_REG0].uns = 0;
    mp[MAP4_INDX_BL+7].uns = 0;
    mp[MAP4_INDX_BL+7].uns = 1;

  } //FIN MAPPER 4


  else if (map == 2) //MAPPER 2
  { //Cargamos el primer y ultimo bloque de PRG.
    fseek(arch,0x10,SEEK_SET); //Ppio Para leer
    fread(&mp[0x8000].uns,sizeof(unsigned char),0x4000,arch);
    fseek(arch,(0x4000)*(prg_bl.uns-1) + 0x10,SEEK_SET); //Ppio Para leer
    fread(&mp[0xC000].uns,sizeof(unsigned char),0x4000,arch);
    //Cargamos los demas bloques PRG.
    fseek(arch,0x4010,SEEK_SET); //Ppio Para leer
    fread(&mp[0x14000].uns,sizeof(unsigned char),0x4000*(prg_bl.uns-2),arch);
    //Cargamos el CHR.
    if (chk_bl.uns != 0)
    {
      fseek(arch,(0x4000)*prg_bl.uns + 0x10,SEEK_SET); //Ppio Para leer
      fread(&mp[0x10000].uns,sizeof(unsigned char),0x2000,arch);
    }
  } //FIN MAPPER 2

  else if (map == 3) //MAPPER 3
  {
    if (prg_bl.uns == 1)
    {//SE CARGAN EL BLOQUE 2 veces en 0x8000 y 0xC000

      fseek(arch,0x10,SEEK_SET); //Ppio Para leer
      fread(&mp[0x8000].uns,sizeof(unsigned char),0x4000,arch);
      fseek(arch,0x10,SEEK_SET); //Ppio Para leer
      fread(&mp[0xC000].uns,sizeof(unsigned char),0x4000,arch);

    }
    else                   //Se cargan los 2 bloques seguidos.
    {
      fseek(arch,0x10,SEEK_SET); //Ppio Para leer
      fread(&mp[0x8000].uns,sizeof(unsigned char),(0x4000)*prg_bl.uns,arch);
    }

    //CARGAMOS el primer CHR-ROM
    fseek(arch,0xA+(0x4000)*prg_bl.uns + 0x6,SEEK_SET); //Ppio Para leer
    fread(&mp[0x10000].uns,sizeof(unsigned char),0x2000,arch);

    //CARGAMOS TODOS LOS DEMAS CHR-ROM
    fseek(arch,(0x4000)*prg_bl.uns + 0x10 + 0x2000,SEEK_SET); //Ppio Para leer
    fread(&mp[0x14000].uns,sizeof(unsigned char),0x2000*(chk_bl.uns-1),arch);
  } //FIN MAPPER 3


  printf("The ROM has been succesfully loaded:\n\n");
  printf("%i 16KB PRG banks loaded !!!\n", prg_bl.uns);
  printf("%i  8KB CHK banks loaded !!!\n", chk_bl.uns);
  if (mirror == 0) printf("Horizontal mirroring detected!!!\n");
  else printf("Vertical mirroring detected !!!\n");
  printf("Mapper #%i detected\n\n", map);

  printf("PC initialized at %p\n\n", 256*mp[0xFFFD].uns + mp[0xFFFC].uns);


  //INICIALIZAMOS de 0 a 0x2000 con 00 00 00 00 FF FF FF FF 00 00 00 00 FF FF FF FF
  //Solo si hay un bl de prg.

  //if (prg_bl.uns == 1)

  //{

  int i;
  for (i = 0; i< 0x800; i++)
  {
    switch (i%16)
    {
    case 4:
      mp[i].uns = 0xff;
      break;
    case 5:
      mp[i].uns = 0xff;
      break;
    case 6:
      mp[i].uns = 0xff;
      break;
    case 7:
      mp[i].uns = 0xff;
      break;
    case 12:
      mp[i].uns = 0xff;
      break;
    case 13:
      mp[i].uns = 0xff;
      break;
    case 14:
      mp[i].uns = 0xff;
      break;
    case 15:
      mp[i].uns = 0xff;
      break;

    default:
      break;

    }

  }

  mp[0x1fe].uns = 0x30;
  mp[0x1ff].uns = 0x02;

  //HORA DE ASIGNAR COSAS a la variable MP

  mp[MIR].uns = mirror;
  mp[MAPPER].uns = map;
  mp[PRG_BL] = prg_bl;
  mp[CHR_BL] = chk_bl;

  return mp;

}

int inline leer_mp (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir,
                    unsigned long ciclo)
{
  switch(mp[MAPPER].uns)
  {
  case 0:
    leer_mp0(dato,mp,dir);
    break;

  case 1:
    if (dir.uns >= 0x8000) leer_mp1(dato,mp,dir);
    else
      leer_mp0(dato,mp,dir);
    break;

  case 2:
    if ((dir.uns >= 0x8000) && (dir.uns < 0xc000))
    {
      if (mp[MAP2_3_BL].uns == 0) leer_mp0(dato,mp,dir);
      else dato[0] = mp[(0x14000 - 0x8000 + (mp[MAP2_3_BL].uns-1)*0x4000) + dir.uns];

    }
    else
      leer_mp0(dato,mp,dir);
    break;

  case 4:
    if ((dir.uns >= 0x8000) && (dir.uns < 0xE000)) leer_mp4(dato,mp,dir);
    else
      leer_mp0(dato,mp,dir);
    break;

  default:
    leer_mp0(dato,mp,dir);
    break;

  }
}

int inline leer_mp0 (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir)

{

  if (dir.uns < 0x2000)
  {
    dir.uns = dir.uns & 0x7FF;
    dato[0].uns = mp[dir.uns].uns;
  }
  else if (dir.uns >= 0x8000) //Optimizamos pa leer de la PRG-ROM
  {dato[0].uns = mp[dir.uns].uns;}
  else if ((dir.uns == 0x4016) || (dir.uns == 0x4017)) //lectura o escritura en joypads
  {pad_proc(mp); //Miramos el PAD (Comentado para depurar)
    leer_joypad(dato,mp,dir);}

  else if ((dir.uns >= 0x2008) && (dir.uns < 0x4000)) //mirror cada 8
  {dato[0].uns = mp[((dir.uns - 0x2000) % 8) + 0x2000].uns;}

  //PUERTOS PPU
  else if ((dir.uns == 0x2002) || (dir.uns == 0x2007)) //Reg Estado.
  {leer_mp_ppu(dato,mp,dir);}
  else if (dir.uns == 0x2003)//Dir SPR-RAM
  {;}
  else if (dir.uns == 0x2004)//Datos SPR-RAM
  {leer_mp_ppu(dato,mp,dir);}
  else if (dir.uns == 0x2006)
  {;}
  else if (dir.uns == 0x2007)
  {leer_mp_ppu(dato,mp,dir);}

  //FIN PUERTOS PPU
  else
  {//printf("leod e aki\n");
    dato[0].uns = mp[dir.uns].uns;
  }
  return 0;
}

int inline leer_mp1 (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir)
{
  if ((mp[MAP1_REG0].uns & 0x08) != 0) //16k
  {
    if ((mp[MAP1_REG0].uns & 0x04) != 0) //8000 SWAP (como MAPPER 2)
    {if ((dir.uns >= 0x8000) && (dir.uns < 0xc000))
      {
        if (mp[MAP1_REG3].uns == 0) leer_mp0(dato,mp,dir);
        else dato[0] = mp[(0x14000 - 0x8000 + (mp[MAP1_REG3].uns-1)*0x4000) + dir.uns];
      }
      else
        leer_mp0(dato,mp,dir);
    }//FIN 8000 Swap

    else //C000 SWAP
    {
      if (dir.uns >= 0xC000)
      {
        if (mp[MAP1_REG3].uns == (mp[PRG_BL].uns - 1)) leer_mp0(dato,mp,dir);
        else dato[0] = mp[(0x14000 - 0xC000 + (mp[MAP1_REG3].uns-1)*0x4000) + dir.uns];
      }
      else
        leer_mp0(dato,mp,dir);
    }  //FIN C000 SWAP

  }

  else //32K
  {
    //printf("32k\n");

    if ((mp[MAP1_REG3].uns >> 1) == 0) //Es primer bloke.
    {
      if (dir.uns >= 0xC000)
      {
        dato[0].uns = mp[0x14000 - 0xC000 + dir.uns].uns;
      }
      else leer_mp0(dato,mp,dir);
    }
    else if (((mp[MAP1_REG3].uns >> 1)+1)*2 == mp[PRG_BL].uns) //Es ultimo bloke.
    {
      if (dir.uns < 0xC000)
      {
        dato[0].uns = mp[0x14000 - 0x8000 + (mp[PRG_BL].uns-3)*0x4000 + dir.uns].uns;
      }
      else leer_mp0(dato,mp,dir);
    }
    else //Resto blokes.
    {
      dato[0] = mp[(0x14000 - 0x8000 + ((mp[MAP1_REG3].uns >> 1)-1)*0x8000) + dir.uns];
    }

  }

}

int inline leer_mp4 (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir)
{
  if ((mp[MAP4_REG0].uns & 0x40) != 0) //S = 1
  {
  }
  else                                 //S = 0
  {
    if (dir.uns > 0xC000) //Leer normal
      dato[0] = mp[0x14000 + 4000*(mp[PRG_BL].uns-1) - 0xC000];
    else if (dir.uns > 0xA000) //Segundos 8k (7)
    {//if mp[MAP4_]
    }
    else                       //Primeros 8k (6)
    {}}

}

int inline escribir_mp (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir,
                        unsigned long ciclo)

{
  switch(mp[MAPPER].uns)
  {
  case 0:
    escribir_mp0(dato,mp,dir);
    break;

  case 1:
    if (dir.uns >= 0x8000) escribir_mp1(dato,mp,dir);
    else
      escribir_mp0(dato,mp,dir);
    break;

  case 2:
    if (dir.uns >= 0x8000) mp[MAP2_3_BL] = dato[0];
    else
      escribir_mp0(dato,mp,dir);
    break;

  case 3:
    if (dir.uns >= 0x8000) mp[MAP2_3_BL] = dato[0];
    else
      escribir_mp0(dato,mp,dir);
    break;

  case 4:
    if (dir.uns >= 0x8000) escribir_mp4(dato,mp,dir);
    else
      escribir_mp0(dato,mp,dir);
    break;

  default:
    escribir_mp0(dato,mp,dir);
    break;

  }

}


int inline escribir_mp0 (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir)

{
  if (dir.uns < 0x2000)
  {
    dir.uns = dir.uns & 0x7FF;
    mp[dir.uns].uns = dato[0].uns;
  }

  else if (dir.uns >= 0x8000) //Optimizamos pa leer de la PRG-ROM
  {;} //NO SE ESCRIBE AHI
  else if ((dir.uns == 0x4016) || (dir.uns == 0x4017)) //lectura o escritura en joypads
  {escribir_joypad(dato,mp,dir);}

  else if ((dir.uns >= 0x2008) && (dir.uns < 0x4000)) //mirror cada 8
  {mp[((dir.uns - 0x2000) % 8) + 0x2000].uns;}
  //PUERTOS PPU
  else if ((dir.uns == 0x2000) || (dir.uns == 0x2001))
  {
    if (mp[0x8FF].uns == 0) mp[0x8FF].uns = 1; //Se debe redibujar
    mp[dir.uns].uns = dato[0].uns;
  }

  else if (dir.uns == 0x2003)//Dir SPR-RAM
  {if (mp[0x8FF].uns == 0) mp[0x8FF].uns = 1; //Se debe redibujar
    escribir_mp_ppu(dato,mp,dir);}

  else if (dir.uns == 0x2004)//Datos SPR-RAM
  {if (mp[0x8FF].uns == 0) mp[0x8FF].uns = 1; //Se debe redibujar
    escribir_mp_ppu(dato,mp,dir);}

  else if (dir.uns == 0x2005) //Registro maligno de scroll
  {if (mp[0x8FF].uns == 0) mp[0x8FF].uns = 1; //Se debe redibujar
    //printf("Se kiere usar esta cosa maligna\n");
    escribir_mp_ppu(dato,mp,dir);
  }

  else if (dir.uns == 0x2006)
  {
    if (mp[0x8FF].uns == 0) mp[0x8FF].uns = 1;//Se debe redibujar
    escribir_mp_ppu(dato,mp,dir);
  }

  else if (dir.uns == 0x2007) //Datos VRAM
  {if (mp[0x8FF].uns == 0) mp[0x8FF].uns = 1; //Se debe redibujar

    escribir_mp_ppu(dato,mp,dir);}

  else if (dir.uns == 0x4014) //DMA SPR-RAM
  {if (mp[0x8FF].uns == 0) mp[0x8FF].uns = 1; //Se debe redibujar
    mp[0xA01].uns = 0; //Iteracion 0
    mp[0xA02].uns = dato[0].uns; //El N
    mp[0xA03].uns = 1; //Hagamos DMA my friend.
  }

  //FIN PUERTOS PPU
  else
  {mp[dir.uns].uns = dato[0].uns;}
  return 0;
}


int inline escribir_mp1 (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir)
{
  //Miramos si hay reset:
  if ((dato[0].uns & 0x80) != 0)  //RESET
  {
    mp[MAP1_CONT].uns = 0;
    mp[MAP1_REG0].uns = (mp[MAP1_REG0].uns | 0x0C);
  }
  else //PROCEDER NORMAL
  {
    mp[MAP1_TEMP].uns = ((dato[0].uns & 0x01) << mp[MAP1_CONT].uns) | mp[MAP1_TEMP].uns;
    mp[MAP1_CONT].uns++;
    if (mp[MAP1_CONT].uns >= 5) //Poner contador a CERO y llevar a REG_X
    {mp[MAP1_CONT].uns = 0;

      if (dir.uns <= 0x9fff) //REG 0
      {mp[MAP1_REG0] = mp[MAP1_TEMP];
        mp[MIR].uns = mp[MAP1_TEMP].uns & 0x01;}
      else if ((dir.uns >= 0xA000) && (dir.uns <= 0xBFFF))//REG1
        mp[MAP1_REG1] = mp[MAP1_TEMP];
      else if ((dir.uns >= 0xC000) && (dir.uns <= 0xDFFF))//REG2
        mp[MAP1_REG2] = mp[MAP1_TEMP];
      else
        mp[MAP1_REG3] = mp[MAP1_TEMP];

      mp[MAP1_TEMP].uns = 0;
    }
  }

}

int inline escribir_mp4 (union tipo_palabra8* dato, union tipo_palabra8* mp, union tipo_palabra16 dir)
{
  if (dir.uns == 0x8000)
    mp[MAP4_REG0] = dato[0];
  else if (dir.uns == 0x8001)
    mp[MAP4_INDX_BL + (mp[MAP4_REG0].uns & 0x0F)] = dato[0];

}
