#include <SDL/SDL.h>
#include "palabras.c"
#include "joypad.h"
//#include <SDL_thread.h>
#include "ppu.h"
#include "config.h"

void* init_sdl(char full_screen)

{

  if ( SDL_Init(SDL_INIT_VIDEO) < 0 )
  {
    printf("Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }
  //atexit(SDL_Quit);
  //SDL_WM_SetIcon(SDL_LoadBMP("EmilNES.bmp"), NULL);
      
  SDL_Surface *screen;
  SDL_WM_SetCaption(VERSION,NULL);
      
  if (full_screen == 0)
  screen=SDL_SetVideoMode(320,240,16,SDL_HWSURFACE|SDL_DOUBLEBUF);
  else
  {
  screen=SDL_SetVideoMode(320,240,16,SDL_FULLSCREEN);
  //SDL_ShowCursor(SDL_DISABLE);
  }
  
  if ( screen == NULL )
  {
    printf("Unable to set 640x480 video: %s\n", SDL_GetError());
    exit(1);
  
  
  return screen;
    
  }
}

int gestorev(int* halt, int* reset, int* traza, int* save, int* load, int* fr_inc,
             /*union tipo_palabra8* mp,*/ void* screen)

   {SDL_Event evento;
    
     SDL_PollEvent(&evento);
         switch (evento.type) {

			case SDL_QUIT:
				halt[0] = 1;
				return;
	
				break;
	
			default: 
            //Q para Quit el emulador
            if ( evento.key.keysym.sym == SDLK_ESCAPE ) { halt[0] = 1; 
                                                           return;    }
            //R para resetear el emulador.                                                                                                                      
            else if ( evento.key.keysym.sym == SDLK_r )  reset[0] = 1; 
            //T para entrar en modo traza.                                                                                                                                    
            else if ( evento.key.keysym.sym == SDLK_t )  traza[0] = 1; 
                                                 
           //SAVE STATES
           else if ( evento.key.keysym.sym == SDLK_F1 ) { save[0]++;                                               
                                                     SDL_Delay(100);
                                                       }                                                
           else if ( evento.key.keysym.sym == SDLK_F2 ) { save[0]++; 
                                                     if (save[0] == 2) save[0] = 4;                                              
                                                     SDL_Delay(100);
                                                       }      
           else if ( evento.key.keysym.sym == SDLK_F3 ) { save[0]++; 
                                                     if (save[0] == 2) save[0] = 6;                                              
                                                     SDL_Delay(100);
                                                       } 
             //LOAD STATES
           else if ( evento.key.keysym.sym == SDLK_F4 ) { load[0]++;                                               
                                                     SDL_Delay(100);
                                                       } 
           else if ( evento.key.keysym.sym == SDLK_F5 ) { load[0]++; 
                                                     if (load[0] == 2) load[0] = 4;                                              
                                                     SDL_Delay(100);
                                                       }      
           else if ( evento.key.keysym.sym == SDLK_F6 ) { load[0]++; 
                                                     if (load[0] == 2) load[0] = 6;                                              
                                                     SDL_Delay(100);
                                                       } 
                                                       
           else if ( evento.key.keysym.sym == SDLK_KP_PLUS) { fr_inc[0]++; 
                                                      //printf("hola q tal\n");
                                                     SDL_Delay(100);
                                                       } 
                                                       
           else if ( evento.key.keysym.sym == SDLK_KP_MINUS ) { fr_inc[0]--;                                                      
                                                     SDL_Delay(100);
                                                       } 
           
            
          //NO CAMBIA BIEN EL TAMANO PANTALLA
          /*  if ( evento.key.keysym.sym == SDLK_f )
                   {
                    halt[0] = 2;
                    SDL_Delay(50);
                    screen=SDL_SetVideoMode(320,240,16,SDL_FULLSCREEN);  
                    halt[0] = 0;  
                    }
           */
           evento.key.keysym.sym = 0; //cutrada
           }//end case   
   // }//end loop

}//end function

float auto_skip(unsigned long* skip, int ips)

{
 float factor;
 int i=1;
 int ips_inicial = ips;  
 for (i=1; ips < IPS_REAL; i++)
  ips+=ips_inicial;

 *skip=i;
 factor = ((float)ips)/((float)IPS_REAL);


 printf("Frame Skip set to: %ix\nRunning at %.4fx original NES speed\n\n"
        ,skip[0] , factor);

return factor;
 
}

void update_screen(void* screen)

    {//if ( SDL_MUSTLOCK(screen) ) {
      //  if ( SDL_LockSurface(screen) < 0 ) 
        //    {
          //  fprintf(stderr, "Can't lock screen: %s\n", SDL_GetError());
           // }
             //                    }
    SDL_Flip(screen);
    //SDL_UpdateRect(screen,32,0,256,240);
    
   // if ( SDL_MUSTLOCK(screen) ) {
    //    SDL_UnlockSurface(screen);
   // }
    
    }


void putpixel(SDL_Surface *surface, int x, int y, unsigned int pixel)
{
    //int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * 2;//bpp;

    /*switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:*/
        *(Uint16 *)p = pixel;
        /*break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }*/
}

unsigned int RGB_a_UInt(SDL_Surface* screen, unsigned char r ,unsigned char g, unsigned char b)

    {
      return SDL_MapRGB(screen->format,r ,g, b);    
    }    



void   cerrar_SDL()
     {
     SDL_Quit();
     }
